//+------------------------------------------------------------------+
//|                                              YD_Patern123_03.mq4 |
//+------------------------------------------------------------------+


 
#property indicator_chart_window
#property copyright   "2015, Dmitry Yurkov"  // copyright  
#property version     "3.00"                 //                                                  
#property description "This indicator finds Pattern 123" // 
#property strict

extern int MaxBars=1000;
extern bool UseClose=false;

extern string    ZigZag = "------ ZigZag  ---------";
extern  int      Depth            =      12; // Depth
extern  int      Deviation        =       5; // Deviation
extern  int      Backstep         =       3; // Backstep

extern string    Limits = "------ DistanseLimits  ---------";
extern  int      DistanseLimits_1_2_min = 2;
extern  int      DistanseLimits_1_2_max = 500;
extern  int      DistanseLimits_2_3_min = 2;
extern  int      DistanseLimits_2_3_max = 500;

extern string    Colors  = " ---- COLORS -----";
extern color     PatternDown        = clrDodgerBlue;      // 
extern color     PatternUp         = clrGold; // 
extern string    Value = "------ The value of price tags  ---------";
extern int       Width=1;
//-------
string nms,nmb; int mp; int zu1,zu2,zu3,zu4;
//---------------------------------------------------------------------------
void DeleteObjects(string text)
  {
   string name;
   for(int i=ObjectsTotal()-1; i>=0; i--)
     {
      name=ObjectName(i);
      if(StringFind(name,text)>-1) ObjectDelete(name);
     }
  }  
//-------------------------------------------------------------------
void OnInit()
{  mp=1; if(_Digits==3 || _Digits==5)mp=10;
   DistanseLimits_1_2_min *=mp;DistanseLimits_1_2_max *=mp;
   DistanseLimits_2_3_min *=mp;DistanseLimits_2_3_max *=mp;
   nms="s_zz_"+_Symbol;
   nmb="b_zz_"+_Symbol;
}
//-------------------------------------------------------------------- 
void OnDeinit(const int reason)
{
  DeleteObjects("zz");
  DeleteObjects("metka");
}
//-------------------------------------------------------------------- 
int OnCalculate( const int rates_total,      //   
                 const int prev_calculated,  //     
                 const datetime &time[],     // Time
                 const double &open[],       // Open
                 const double &high[],       // High
                 const double &low[],        // Low
                 const double &close[],      // Close
                 const long &tick_volume[],  // Tick Volume
                 const long &volume[],       // Real Volume
                 const int &spread[]         // Spread
                 )
{
  DeleteObjects("zz");
  DeleteObjects("metka");
  int bars=MaxBars;//WindowBarsPerChart(); 
  int nzz=0;
  for(int k=1; k<=bars; k++)
     {
      double zz=0;
      zz=iCustom(NULL,0,"ZigZag", Depth,Deviation,Backstep,0,k);
      if(zz>0)
      {
         if(nzz==0){Pattern0(k);nzz++;}
         else Pattern(k);
      }
     } 
     zu1=0;
     zu2=0;
     zu3=0;
     zu4=0;
   return(0);
}
//--------------------------------------------------------
double ND(double x){return(NormalizeDouble(x,_Digits));}
//--------------------------------------------------------
void Pattern(int shift){
double zz=0,ZZ0=0,ZZ1=0,ZZ2=0,ZZ3=0,ZZ4=0,cl1=0,cl2=0;
int cnt=0,T0=0,T1=0,T2=0,T3=0,T4=0,bars=iBars(Symbol(),0),zu=0,zuk=0;
for(int i=shift; i<Bars; i++)
{
    zz=0;
    zz=iCustom(NULL,0,"ZigZag", Depth,Deviation,Backstep,0,i);
    if(zz!=0 && cnt==0)           {ZZ0=zz; T0=(int)Time[i]; cnt=1; continue;}
    if(cnt==1)if(zz!=0 && zz!=ZZ0){ZZ1=zz; T1=(int)Time[i]; cnt=2; continue;}
    if(cnt==2)if(zz!=0 && zz!=ZZ1){ZZ2=zz; T2=(int)Time[i]; cnt=3; continue;}
    if(cnt==3)if(zz!=0 && zz!=ZZ2){ZZ3=zz; T3=(int)Time[i]; cnt=4; break;}
}





   if(ZZ0<ZZ1 && ZZ0<ZZ2)// DN
   {
      if(ZZ1>ZZ2 && ZZ3>ZZ1)
      {
         if(ZZ1-ZZ2>=DistanseLimits_1_2_min*_Point && ZZ1-ZZ2<=DistanseLimits_1_2_max*_Point)
         {
            if(ZZ3-ZZ2>=DistanseLimits_2_3_min*_Point && ZZ3-ZZ2<=DistanseLimits_2_3_max*_Point)
             {
                SetLine(StringConcatenate(nms,IntegerToString(shift)),ZZ2,T2,ZZ1,T1,PatternDown,0,3);
                
zu=iBarShift(Symbol(),0,T1);

if(zu1<zu)
{
cl2=Close[iLowest(Symbol(),0,MODE_CLOSE,zu-zu1,zu1)];
zu1=0;
}

if(zu1==0) zu1=iBarShift(Symbol(),0,T2);

                
                if((UseClose && cl2<ZZ2) || !UseClose)
                {
                SetFibo(StringConcatenate("fb",nms,IntegerToString(shift)),ZZ2,T2,ZZ1,T1,PatternDown,0,0);
                
                ObjectCreate("metka1"+DoubleToStr(T2,0),OBJ_ARROW,0,T2,ZZ1);
                ObjectSet("metka1"+DoubleToStr(T2,0),OBJPROP_ARROWCODE,5);
                ObjectSet("metka1"+DoubleToStr(T2,0),OBJPROP_COLOR,PatternDown);
                ObjectSet("metka1"+DoubleToStr(T2,0),OBJPROP_WIDTH,Width);
                
                ObjectCreate("metka2"+DoubleToStr(T2,0),OBJ_ARROW,0,T2,ZZ2);
                ObjectSet("metka2"+DoubleToStr(T2,0),OBJPROP_ARROWCODE,5);
                ObjectSet("metka2"+DoubleToStr(T2,0),OBJPROP_COLOR,PatternDown);
                ObjectSet("metka2"+DoubleToStr(T2,0),OBJPROP_WIDTH,Width);
                
                ObjectCreate("metka3"+DoubleToStr(T2,0),OBJ_ARROW,0,T2,NormalizeDouble(ZZ1-(ZZ1-ZZ2)*1.618,Digits));
                ObjectSet("metka3"+DoubleToStr(T2,0),OBJPROP_ARROWCODE,5);
                ObjectSet("metka3"+DoubleToStr(T2,0),OBJPROP_COLOR,PatternDown);
                ObjectSet("metka3"+DoubleToStr(T2,0),OBJPROP_WIDTH,Width);
                
                ObjectCreate("metka4"+DoubleToStr(T2,0),OBJ_ARROW,0,T2,NormalizeDouble(ZZ1-(ZZ1-ZZ2)*2.618,Digits));
                ObjectSet("metka4"+DoubleToStr(T2,0),OBJPROP_ARROWCODE,5);
                ObjectSet("metka4"+DoubleToStr(T2,0),OBJPROP_COLOR,PatternDown);
                ObjectSet("metka4"+DoubleToStr(T2,0),OBJPROP_WIDTH,Width);
                                
                }
                
             }
         }
      }
   }
   
   if(ZZ0>ZZ1 && ZZ0>ZZ2)// UP
   {
      if(ZZ1<ZZ2 && ZZ3<ZZ1)
      {
         if(ZZ2-ZZ1>=DistanseLimits_1_2_min*_Point && ZZ2-ZZ1<=DistanseLimits_1_2_max*_Point)
         {
            if(ZZ2-ZZ3>=DistanseLimits_2_3_min*_Point && ZZ2-ZZ3<=DistanseLimits_2_3_max*_Point)
            {
               SetLine(StringConcatenate(nmb,IntegerToString(shift)),ZZ2,T2,ZZ1,T1,PatternUp,0,3);
               
zu=iBarShift(Symbol(),0,T1);

if(zu2<zu)
{
cl1=Close[iHighest(Symbol(),0,MODE_CLOSE,zu-zu2,zu2)];
zu2=0;
}

if(zu2==0) zu2=iBarShift(Symbol(),0,T2);
               
               if((UseClose && cl1>ZZ2) || !UseClose)
               {
               SetFibo(StringConcatenate("fb",nmb,IntegerToString(shift)),ZZ2,T2,ZZ1,T1,PatternUp,0,0);
               
                ObjectCreate("metka5"+DoubleToStr(T2,0),OBJ_ARROW,0,T2,ZZ1);
                ObjectSet("metka5"+DoubleToStr(T2,0),OBJPROP_ARROWCODE,5);
                ObjectSet("metka5"+DoubleToStr(T2,0),OBJPROP_COLOR,PatternUp);
                ObjectSet("metka5"+DoubleToStr(T2,0),OBJPROP_WIDTH,Width);
                
                ObjectCreate("metka6"+DoubleToStr(T2,0),OBJ_ARROW,0,T2,ZZ2);
                ObjectSet("metka6"+DoubleToStr(T2,0),OBJPROP_ARROWCODE,5);
                ObjectSet("metka6"+DoubleToStr(T2,0),OBJPROP_COLOR,PatternUp);
                ObjectSet("metka6"+DoubleToStr(T2,0),OBJPROP_WIDTH,Width);
                
                ObjectCreate("metka7"+DoubleToStr(T2,0),OBJ_ARROW,0,T2,NormalizeDouble(ZZ1+(ZZ2-ZZ1)*1.618,Digits));
                ObjectSet("metka7"+DoubleToStr(T2,0),OBJPROP_ARROWCODE,5);
                ObjectSet("metka7"+DoubleToStr(T2,0),OBJPROP_COLOR,PatternUp);
                ObjectSet("metka7"+DoubleToStr(T2,0),OBJPROP_WIDTH,Width);
                
                ObjectCreate("metka8"+DoubleToStr(T2,0),OBJ_ARROW,0,T2,NormalizeDouble(ZZ1+(ZZ2-ZZ1)*2.618,Digits));
                ObjectSet("metka8"+DoubleToStr(T2,0),OBJPROP_ARROWCODE,5);
                ObjectSet("metka8"+DoubleToStr(T2,0),OBJPROP_COLOR,PatternUp);
                ObjectSet("metka8"+DoubleToStr(T2,0),OBJPROP_WIDTH,Width);
               
               }
            }
         }
      }
   }
}
//--------------------------------------------------------
void Pattern0(int shift)
{
   double zz=0,ZZ0=0,ZZ1=0,ZZ2=0,ZZ3=0,ZZ4=0,cl1=0,cl2=0; int cnt=0; 
   int T0=0,T1=0,T2=0,T3=0,T4=0,zu=0;
   int bars=iBars(Symbol(),0);
   
   for(int i=shift; i<Bars; i++)
   {
      zz=0;
      zz=iCustom(NULL,0,"ZigZag", Depth,Deviation,Backstep,0,i);
      if(zz!=0 && cnt==0)           {ZZ0=zz; T0=(int)Time[i]; cnt=1; continue;}
      if(cnt==1)if(zz!=0 && zz!=ZZ0){ZZ1=zz; T1=(int)Time[i]; cnt=2; continue;}
      if(cnt==2)if(zz!=0 && zz!=ZZ1){ZZ2=zz; T2=(int)Time[i]; cnt=3; continue;}
      if(cnt==3)if(zz!=0 && zz!=ZZ2){ZZ3=zz; T3=(int)Time[i]; cnt=4; break;}
   }
   
      
   if(ZZ0<ZZ1)// DN
   {
      if(ZZ1>ZZ2 && ZZ3>ZZ1)
      {
         if(ZZ1-ZZ2>=DistanseLimits_1_2_min*_Point && ZZ1-ZZ2<=DistanseLimits_1_2_max*_Point)
         {
            if(ZZ3-ZZ2>=DistanseLimits_2_3_min*_Point && ZZ3-ZZ2<=DistanseLimits_2_3_max*_Point)
            {
               SetLine(StringConcatenate(nms,IntegerToString(shift)),ZZ2,T2,ZZ1,T1,PatternDown,0,3);
               
zu=iBarShift(Symbol(),0,T1);

if(zu3<zu)
{
cl2=Close[iLowest(Symbol(),0,MODE_CLOSE,zu-zu3,zu3)];
zu3=0;
}

if(zu3==0) zu3=iBarShift(Symbol(),0,T2);
               
               if((ZZ0<ZZ2 && !UseClose) || (UseClose && cl2<ZZ2))
               {
                  SetFibo(StringConcatenate("fb",nms,IntegerToString(shift)),ZZ2,T2,ZZ1,T1,PatternDown,0,0);
                  
                ObjectCreate("metka11"+DoubleToStr(T2,0),OBJ_ARROW,0,T2,ZZ1);
                ObjectSet("metka11"+DoubleToStr(T2,0),OBJPROP_ARROWCODE,5);
                ObjectSet("metka11"+DoubleToStr(T2,0),OBJPROP_COLOR,PatternDown);
                ObjectSet("metka11"+DoubleToStr(T2,0),OBJPROP_WIDTH,Width);
                
                ObjectCreate("metka21"+DoubleToStr(T2,0),OBJ_ARROW,0,T2,ZZ2);
                ObjectSet("metka21"+DoubleToStr(T2,0),OBJPROP_ARROWCODE,5);
                ObjectSet("metka21"+DoubleToStr(T2,0),OBJPROP_COLOR,PatternDown);
                ObjectSet("metka21"+DoubleToStr(T2,0),OBJPROP_WIDTH,Width);
                
                ObjectCreate("metka31"+DoubleToStr(T2,0),OBJ_ARROW,0,T2,NormalizeDouble(ZZ1-(ZZ1-ZZ2)*1.618,Digits));
                ObjectSet("metka31"+DoubleToStr(T2,0),OBJPROP_ARROWCODE,5);
                ObjectSet("metka31"+DoubleToStr(T2,0),OBJPROP_COLOR,PatternDown);
                ObjectSet("metka31"+DoubleToStr(T2,0),OBJPROP_WIDTH,Width);
                
                ObjectCreate("metka41"+DoubleToStr(T2,0),OBJ_ARROW,0,T2,NormalizeDouble(ZZ1-(ZZ1-ZZ2)*2.618,Digits));
                ObjectSet("metka41"+DoubleToStr(T2,0),OBJPROP_ARROWCODE,5);
                ObjectSet("metka41"+DoubleToStr(T2,0),OBJPROP_COLOR,PatternDown);
                ObjectSet("metka41"+DoubleToStr(T2,0),OBJPROP_WIDTH,Width);
                  
               }
            }
         }
      }
   }
   
   if(ZZ0>ZZ1)// UP
   {
      if(ZZ1<ZZ2 && ZZ3<ZZ1)
      {
         if(ZZ2-ZZ1>=DistanseLimits_1_2_min*_Point && ZZ2-ZZ1<=DistanseLimits_1_2_max*_Point)
         {
            if(ZZ2-ZZ3>=DistanseLimits_2_3_min*_Point && ZZ2-ZZ3<=DistanseLimits_2_3_max*_Point)
            {
               SetLine(StringConcatenate(nmb,IntegerToString(shift)),ZZ2,T2,ZZ1,T1,PatternUp,0,3);
               
zu=iBarShift(Symbol(),0,T1);

if(zu4<zu)
{
cl1=Close[iHighest(Symbol(),0,MODE_CLOSE,zu-zu4,zu4)];
zu4=0;
}

if(zu4==0) zu4=iBarShift(Symbol(),0,T2);
               
               if((ZZ0>ZZ2 && !UseClose) || (UseClose && cl1>ZZ2))
               {
                  SetFibo(StringConcatenate("fb",nmb,IntegerToString(shift)),ZZ2,T2,ZZ1,T1,PatternUp,0,0);
                  
                ObjectCreate("metka51"+DoubleToStr(T2,0),OBJ_ARROW,0,T2,ZZ1);
                ObjectSet("metka51"+DoubleToStr(T2,0),OBJPROP_ARROWCODE,5);
                ObjectSet("metka51"+DoubleToStr(T2,0),OBJPROP_COLOR,PatternUp);
                ObjectSet("metka51"+DoubleToStr(T2,0),OBJPROP_WIDTH,Width);
                
                ObjectCreate("metka61"+DoubleToStr(T2,0),OBJ_ARROW,0,T2,ZZ2);
                ObjectSet("metka61"+DoubleToStr(T2,0),OBJPROP_ARROWCODE,5);
                ObjectSet("metka61"+DoubleToStr(T2,0),OBJPROP_COLOR,PatternUp);
                ObjectSet("metka61"+DoubleToStr(T2,0),OBJPROP_WIDTH,Width);
                
                ObjectCreate("metka71"+DoubleToStr(T2,0),OBJ_ARROW,0,T2,NormalizeDouble(ZZ1+(ZZ2-ZZ1)*1.618,Digits));
                ObjectSet("metka71"+DoubleToStr(T2,0),OBJPROP_ARROWCODE,5);
                ObjectSet("metka71"+DoubleToStr(T2,0),OBJPROP_COLOR,PatternUp);
                ObjectSet("metka71"+DoubleToStr(T2,0),OBJPROP_WIDTH,Width);
                
                ObjectCreate("metka81"+DoubleToStr(T2,0),OBJ_ARROW,0,T2,NormalizeDouble(ZZ1+(ZZ2-ZZ1)*2.618,Digits));
                ObjectSet("metka81"+DoubleToStr(T2,0),OBJPROP_ARROWCODE,5);
                ObjectSet("metka81"+DoubleToStr(T2,0),OBJPROP_COLOR,PatternUp);
                ObjectSet("metka81"+DoubleToStr(T2,0),OBJPROP_WIDTH,Width);
               }
            }
         }
      }
   }
   
  
}
//------------------------------------------------------------------
//------------------------------------------------------------------
void SetLine(string name, double price1,int time1,double price2, int time2, color LineColor, int style,int width)
{
  // if(ObjectFind(name)!= -1)ObjectDelete(name); 
   ObjectCreate(name,OBJ_TREND,0,0,0,0,0);
   ObjectSet(name,OBJPROP_STYLE,style);
   ObjectSet(name,OBJPROP_WIDTH,width);
   ObjectSet(name,OBJPROP_COLOR,LineColor);
   ObjectSet(name,OBJPROP_TIME1,time1);
   ObjectSet(name,OBJPROP_PRICE1,price1);
   ObjectSet(name,OBJPROP_TIME2,time2);
   ObjectSet(name,OBJPROP_PRICE2,price2);
   ObjectSet(name,OBJPROP_RAY,false); 
}
//----------------------------------------------------------------------------
void SetFibo(string name,double pr1,int tm1,double pr2,int tm2,color col, int st, int wd)
{
   double pr3,pr4;  
   if(col==PatternDown)
   {
     SetLine(name+"_1",pr2,tm1,pr2,tm2,PatternDown,0,0);
     SetLine(name+"_2",pr1,tm1,pr1,tm2,PatternDown,0,0);
     pr3=ND(pr2-(pr2-pr1)*1.618);
     pr4=ND(pr2-(pr2-pr1)*2.618);
     SetLine(name+"_3",pr3,tm1,pr3,tm2,PatternDown,0,0);
     SetLine(name+"_4",pr4,tm1,pr4,tm2,PatternDown,0,0);
   }
   if(col==PatternUp)
   {
     SetLine(name+"_1",pr2,tm1,pr2,tm2,PatternUp,0,0);
     SetLine(name+"_2",pr1,tm1,pr1,tm2,PatternUp,0,0);
     pr3=ND(pr2+(pr1-pr2)*1.618);
     pr4=ND(pr2+(pr1-pr2)*2.618);
     SetLine(name+"_3",pr3,tm1,pr3,tm2,PatternUp,0,0);
     SetLine(name+"_4",pr4,tm1,pr4,tm2,PatternUp,0,0);
   }
}